"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
const OtpInput = ({
  filledColor = '#000',
  nonFilledColor = '#fff',
  currentFieldColor = '#ccc',
  totalField = 4,
  onChange = () => {},
  style = {
    flexDirection: 'row',
    alignItems: 'center',
    justifyContent: 'space-between'
  },
  textInputStyle = {}
}) => {
  const repeat = num => {
    return Array(num).fill('');
  };
  const [forgotPasswordOtp, SetForgotPasswordOtp] = (0, _react.useState)(repeat(totalField));
  const [focusedInput, SetFocusInput] = (0, _react.useState)(0);
  (0, _react.useEffect)(() => {
    onChange(forgotPasswordOtp.join(''));
  }, [forgotPasswordOtp, onChange]);
  let EventHandlerOtpScreen = index => {
    return {
      onChangeText: text => handleChangeText(text, index),
      onKeyPress: ({
        nativeEvent
      }) => {
        if ((nativeEvent === null || nativeEvent === void 0 ? void 0 : nativeEvent.key) === 'Backspace') {
          removeTextHandler(index);
        }
      },
      ref: input => {
        if (index === focusedInput && input) {
          input.focus();
        }
      }
    };
  };
  const removeTextHandler = index => {
    let newOtp = [...forgotPasswordOtp];
    if (index === 0) {
      newOtp[index] = '';
      SetForgotPasswordOtp(newOtp);
      SetFocusInput(0);
    } else if (index >= totalField - 1 && newOtp[totalField - 1] !== '') {
      newOtp[index] = '';
      SetForgotPasswordOtp(newOtp);
      SetFocusInput(totalField - 1);
    } else {
      newOtp = [...forgotPasswordOtp];
      newOtp[index - 1] = '';
      SetForgotPasswordOtp(newOtp);
      const prevInput = index - 1;
      SetFocusInput(prevInput);
    }
  };
  const handleChangeText = (text, index) => {
    const newOtp = [...forgotPasswordOtp];
    newOtp[index] = text;
    SetForgotPasswordOtp(newOtp);
    if (text && index < forgotPasswordOtp.length - 1) {
      const nextInput = index + 1;
      SetFocusInput(nextInput);
    }
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: style
  }, forgotPasswordOtp.map((digit, index) => /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    key: index
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, null), /*#__PURE__*/_react.default.createElement(_reactNative.TextInput, _extends({
    style: [textInputStyle, {
      borderColor: index === focusedInput ? currentFieldColor : digit ? filledColor : nonFilledColor
    }],
    value: digit
  }, EventHandlerOtpScreen(index), {
    keyboardType: "numeric",
    maxLength: 1,
    textAlign: 'center',
    testID: "otpDataTestId"
  })))));
};
var _default = exports.default = OtpInput;
//# sourceMappingURL=index.js.map